package cc.smtweb.system.bpm.web.sys.user.user;

import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.framework.core.db.impl.DefaultEntity;
import cc.smtweb.system.bpm.web.design.form.define.PageDataset;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageDelHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageListHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageLoadHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageSaveHandler;

/**
 * Created by Akmm at 2022/7/1 15:47
 * 区划保存
 */
public class UserHandler {

    static class UserSaveHandler extends DynPageSaveHandler {
        private UserStatu userStatu;

        @Override
        protected void saveBean(DefaultEntity bean) {
            super.saveBean(bean);
            userStatu = UserStatuCache.getInstance().get(bean.getEntityId());
            if (userStatu == null || userStatu.isEmpty()) {
                userStatu = new UserStatu();
                userStatu.init();
                userStatu.setEntityId(bean.getEntityId());
                DbEngine.getInstance().findDao(UserStatu.ENTITY_NAME).insertEntity(userStatu);
                UserStatuCache.getInstance().put(userStatu);
            }
        }
    }

    static class UserDelHandler extends DynPageDelHandler {

        @Override
        protected void localDel(long id) {
            super.localDel(id);
            DbEngine.getInstance().findDao(UserStatu.ENTITY_NAME).deleteEntity(id);
        }

        @Override
        protected void localDelSuccess(long id) {
            UserStatuCache.getInstance().remove(id);
        }
    }

    static class UserListHandler extends DynPageListHandler {

        public UserListHandler(long pageId, SwMap filter, PageDataset pageDataSet) {
            super(pageId, filter, pageDataSet);
        }
    }

    static class UserLoadHandler extends DynPageLoadHandler {

        @Override
        public DynPageListHandler getListWorker(SwMap filter, PageDataset pageDataSet) {
            UserListHandler listHandler = new UserListHandler(pageId, filter, pageDataSet);
            listHandler.init(params, us);
            return listHandler;
        }
    }
}
